From e26b11715ea219469737aec9e89580811e1030c8 Mon Sep 17 00:00:00 2001
From: Craig Ringer <craig@2ndquadrant.com>
Date: Wed, 1 Jun 2016 13:50:52 +0800
Subject: [PATCH 8/9] ERROR if timeline is zero in walsender

---
 src/backend/replication/walsender.c | 5 +++++
 1 file changed, 5 insertions(+)

diff --git a/src/backend/replication/walsender.c b/src/backend/replication/walsender.c
index abdacca..694e777 100644
--- a/src/backend/replication/walsender.c
+++ b/src/backend/replication/walsender.c
@@ -521,6 +521,11 @@ StartReplication(StartReplicationCmd *cmd)
 	StringInfoData buf;
 	XLogRecPtr	FlushPtr;
 
+	if (ThisTimeLineID == 0)
+		ereport(ERROR,
+				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+				 errmsg("run IDENTIFY_SYSTEM before trying to START_REPLICATION")));
+
 	/*
 	 * We assume here that we're logging enough information in the WAL for
 	 * log-shipping, since this is checked in PostmasterMain().
-- 
2.5.5

